#include <iostream>
#include <queue>
using namespace std;

struct cell
{
       int x, len;
};

int n, m;
bool a[10010][10010], v[10010];
int b[10010][10010];
int A, B;

int BFS()
{
    if ( A == B )
       return 0;
    queue<cell> q;
    int i, aa;
    cell y, j;
    y.x = A;
    y.len = 0;
    v[A] = 1;
    q.push( y );
    
    while ( !q.empty() )
    {
          j = q.front();
          q.pop();
          
          for ( i = 1; i <= b[j.x][0]; i++ )
          {
              aa = b[j.x][i];
              if ( aa == B )
                 return j.len + 1;
              if ( v[aa] == 0 )
              {
                   v[aa] = 1;
                   y.x = aa;
                   y.len = j.len + 1;
                   q.push( y );
              }
          }
    }
    return -1;
}

void makerebr( int i, int j )
{
     if ( a[i][j] == 1 )
        return;
     b[i][++b[i][0]] = j;
     b[j][++b[j][0]] = i;
     a[i][j] = 1;
     a[j][i] = 1;
}

int main()
{
    int i, j, k;
    int s, t[10010];

    cin >> m >> n;
    for ( i = 1; i <= n; i++ )
    {
        for ( j = 1; j <= n; j++ )
            a[i][j] = 0;
        b[i][0] = 0;
        v[i] = 0;
    }
    
    for ( i = 1; i <= m; i++ )
    {
        cin >> s;
        for ( j = 1; j <= s; j++ )
            cin >> t[j];
        for ( j = 1; j <= s; j++ )
        {
            for ( k = j + 1; k <= s; k++ )
                makerebr( t[j], t[k] );
        }
    }
    cin >> A >> B;
    
    cout << BFS() << endl;
    return 0;
}
