#include <iostream>
#include <cmath>
using namespace std;

int n;

int mini( int a, int b )
{
    if ( a < b )
       return a;
    return b;
}

int findMin( int a )
{
     int root = (int) sqrt( (double) a );
     if ( a % 2 == 0 )
        return 2;
     for ( int i = 3; i <= root; i = i + 2 )
         if ( a % i == 0 )
            return i;
     return -1;
}

int findMid( int a, int b )
{
     int i = b, j = b, res = -1;
     while ( ( a % i != 0 ) && ( a > i ) )
           i++;
     
     while ( ( a % j != 0 ) && ( j > 1 ) )
           j--;
     
     if ( ( abs( i - b ) < abs( j - b ) ) && ( a % i == 0 ) && ( a != i ) )
        res = i;
     else if ( ( a % j == 0 ) && ( j != 1 ) )
          res = j;
     return res;
}

int main()
{
    int i, j;
    int a, b, c, a1, b1, c1, min, min1, max;
    
    cin >> n;
    
    a1 = findMin( n );
    b1 = findMin( n / a1 );
    c1 = ( n / a1 ) / b1;
    max = a1 + b1 + c1;
    if ( ( a1 <= 1 ) || ( b1 <= 1 ) || ( c1 <= 1 ) )
    {
         cout << "0" << endl;
         return 0;
    }
    
    i = 1;
    while ( i * i * i < n )
          i++;
    
    a = findMid( n, i );
    b = findMid( n / a, i );
    c = ( n / a ) / b;
    min = a + b + c;
    if ( ( a <= 1 ) || ( b <= 1 ) || ( c <= 1 ) )
         min = INT_MAX;

    i--;
    a = findMid( n, i );
    b = findMid( n / a, i );
    c = ( n / a ) / b;
    min1 = a + b + c;
    if ( ( a <= 1 ) || ( b <= 1 ) || ( c <= 1 ) )
        min1 = INT_MAX;
    min = mini( min, min1 );
    
    cout << min << " " << max << endl;
    return 0;
}
